.model small
rBufSize EQU 1
.stack 100h
.data



about db 'Kompiuteriu architektura, antra praktine uzduotis 7', 13, 10, 'Programa suskaiciuoja kiek kokio simbolio yra faile', 13, 10, 'Erik Kisel, IT, I kursas, 1 grupe', 13, 10, 'Pvz.: sc srcfile.txt', 13, 10, '$' 
error db 'Parametru klaida: neivesti arba ivesti neteisingai, noredami pamatyti helpa veskite "/?" $'
error1 db 'Klaida, atidarant duomenu faila $'
error2 db 'Klaida, skaitant duomenu faila $' 
error3 db 'Klaida, uzdarant duomenu faila $'
query db 'Iveskite kurio simbolio pasitaikymu kieki skaiciuosime: $'
word0 db 'Jusu simbolis ( $'
word1 db ' ) pasitaiko $'
word2 db ' kartu/-us/-a$'
notFound db 'Tokio simbolio nerasta...$'

line db 100, ?
src db 100 dup (0)
rBuf db rBufSize dup (?)
newln db 13, 10, '$'
handle1 dw ?

.code

begin:

mov ax, @data
mov ds, ax
mov bx, 81h
xor si, si
xor di, di

search:

mov ax, es:[bx]
cmp al, 0Dh
je noHelp
cmp ax, '?/'
je help
inc bx
jmp search

help:

mov dx, offset about
mov ah, 9
int 21h
jmp terminate

noHelp:

mov si, 0080h

searchSpace:

inc si
mov al, es:[si]
cmp al, ' '
je searchSpace
mov bx, offset src

isEndOfParameters:

mov al, es:[si]
inc si
cmp al, 0Dh
jnc searchMore
jmp pError

searchMore:

cmp al, 0Dh
je program
mov ds:[bx], al
inc bx
jmp isEndOfParameters 

pError:

mov dx, offset error
mov ah, 9
int 21h
jmp terminate

program:

cmp src, 0
je  pError

openFile:

mov ah, 3Dh
mov al, 00
mov dx, offset src
int 21h
jc opError
mov handle1, ax
jmp userInteraction

opError:

mov dx, offset error1
mov ah, 9
int 21h
jmp terminate

userInteraction:

xor ax, ax

mov ah, 9
mov dx, offset query
int 21h

xor bx, bx

mov ah, 0ah
mov dx, offset line
int 21h

readFile:

push bx
xor bx, bx
mov bx, handle1
mov ah, 3Fh
mov cl, rBufSize
mov ch, 00
mov dx, offset rBuf
int 21h
jc rError
cmp ax, 0
je closeFile
lea si, rBuf
pop bx
jmp select

rError:

mov dx, offset error2
mov ah, 9
int 21h
jmp terminate

select:
inc di
xor ax, ax
lodsb
push bx
call comparison
loop select
jmp readFile

                                                        

closeFile:

mov bx, handle1
mov ah, 3Eh
int 21h

output:

pop bx
cmp bx, 0
je notFoundSymbol 
mov si, offset [line + 2]

mov ah, 9
mov dx, offset newln
int 21h

mov ah, 9
mov dx, offset word0
int 21h

mov ah, 2
mov dl, [si]
int 21h

mov ah, 9
mov dx, offset word1
int 21h

mov ax, bx
mov bl, 10

xor cx, cx
xor dx, dx

division:

div bl
add ah, '0'
push ax
xor ah, ah
inc cx
cmp al, 0
jne division

num_output:

xor bx, bx
pop ax
mov bl, ah
mov ah, 2
mov dl, bl
int 21h
loop num_output

mov ah, 9
mov dx, offset word2
int 21h
jmp terminate

notFoundSymbol:

mov ah, 9
mov dx, offset newln
int 21h

mov ah, 9
mov dx, offset notFound
int 21h 

terminate:

xor ax, ax
xor cx, cx
mov ax, di
mov bl, 10

dalyba:
inc cx
div bl
push ax
xor ah, ah
cmp al, 0
jne dalyba

print:
xor bx, bx
pop ax
mov bl, ah
add bl, 30h

mov ah, 2
mov dl, bl
int 21h

loop print

mov ax, 4C00h
int 21h

comparison PROC
    
    push si
    mov si, offset [line + 2]
    mov ah, [si]
    cmp ah, al
    je  skaitliukas
    pop si
    ret
    
    skaitliukas:
    inc bx
    pop si
    ret
    
comparison ENDP

END begin